diff -Naur WindowMaker-0.92.0-orig/src/appicon.c WindowMaker-0.92.0/src/appicon.c
--- WindowMaker-0.92.0-orig/src/appicon.c	2007-01-10 23:30:45.000000000 +0100
+++ WindowMaker-0.92.0/src/appicon.c	2007-01-10 23:45:02.000000000 +0100
@@ -60,6 +60,7 @@
 extern WPreferences wPreferences;
 
 #define MOD_MASK       wPreferences.modifier_mask
+#define ICON_SIZE      wPreferences.icon_size
 
 void appIconMouseDown(WObjDescriptor *desc, XEvent *event);
 static void iconDblClick(WObjDescriptor *desc, XEvent *event);
@@ -568,28 +569,12 @@
 }
 
 
-
 void
 appIconMouseDown(WObjDescriptor *desc, XEvent *event)
 {
     WAppIcon *aicon = desc->parent;
     WIcon *icon = aicon->icon;
-    XEvent ev;
-    int x=aicon->x_pos, y=aicon->y_pos;
-    int dx=event->xbutton.x, dy=event->xbutton.y;
-    int grabbed=0;
-    int done=0;
-    int superfluous = wPreferences.superfluous; /* we catch it to avoid problems */
     WScreen *scr = icon->core->screen_ptr;
-    WWorkspace *workspace = scr->workspaces[scr->current_workspace];
-    int shad_x = 0, shad_y = 0, docking=0, dockable, collapsed = 0;
-    int ix, iy;
-    int clickButton = event->xbutton.button;
-    Pixmap ghost = None;
-    Window wins[2];
-    Bool movingSingle = False;
-    int oldX = x;
-    int oldY = y;
 
     if (aicon->editing || WCHECK_STATE(WSTATE_MODAL))
         return;
@@ -624,11 +609,47 @@
         return;
     }
 
+    wHandleAppIconMove(aicon, event);
+}
+
+
+void
+wHandleAppIconMove(WAppIcon *aicon, XEvent *event)
+{
+    /* merger of late appicon.c:appIconMouseDown and dock.c:iconMouseDown */
+    WDock   *original_dock = aicon->dock; /* can be NULL */
+    WIcon   *icon = aicon->icon;
+    WScreen *scr = icon->core->screen_ptr;
+    WDock   *last_dock = original_dock;
+    WDock   *all_docks[scr->drawer_count + 2]; /* fixme */
+    WDrawerChain *dc;
+
+    Bool done = False, dockable, ondock;
+    Bool grabbed = False, collapsed = False;
+    Bool superfluous = wPreferences.superfluous; /* we cache it to avoid problems */
+    Bool omnipresent = aicon->omnipresent;       /* this must be cached!!! */
+    Bool shown_clip_icons = False;
+
+    int      x = aicon->x_pos,         y = aicon->y_pos;
+    int   oldX = x,                 oldY = y;
+    int shad_x = x,               shad_y = y;
+    int  ofs_x = event->xbutton.x, ofs_y = event->xbutton.y;
+    int clickButton = event->xbutton.button;
+    int     ix = aicon->xindex,       iy = aicon->yindex;
+    int i, tmp = 0; /* initialized here to avoid a warning */
+
+    Window wins[2];
+    XEvent ev;
+    Pixmap ghost = None;
+
+    if (wPreferences.flags.noupdates) /* Daniel: was only in dock.c:iconMouseDown */
+	return;
+
 #ifdef DEBUG
-    puts("Moving icon");
+    puts("Moving appicon");
 #endif
     if (event->xbutton.state & MOD_MASK)
-        wLowerFrame(icon->core);
+        wLowerFrame(icon->core); /* Daniel: was only in appicon.c:appIconMouseDown */
     else
         wRaiseFrame(icon->core);
 
@@ -638,23 +659,58 @@
         wwarning("pointer grab failed for appicon move");
     }
 
-    if (wPreferences.flags.nodock && wPreferences.flags.noclip)
-        dockable = 0;
-    else
-        dockable = canBeDocked(icon->owner);
+    if (original_dock) {
+        dockable = True;
+        ondock = True;
+    } else {
+        ondock = False;
+        if (wPreferences.flags.nodock && wPreferences.flags.noclip)
+            dockable = False;
+        else
+            dockable = canBeDocked(icon->owner);
+    }
+
+    /* We try the various docks in that order:
+     * - First, the dock the appicon comes from, if any
+     * - Then, the drawers
+     * - Then, the "dock" (WM_DOCK)
+     * - Eventually, the clip
+     */
+    i = 0;
+    if (original_dock != NULL)
+        all_docks[ i++ ] = original_dock;
+    for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+        if (dc->adrawer != original_dock)
+            all_docks[ i++ ] = dc->adrawer;
+    }
+    if (!wPreferences.flags.nodock && scr->dock != original_dock) {
+        all_docks[ i++ ] = scr->dock;
+    }
+    if (!wPreferences.flags.noclip &&
+        original_dock != scr->workspaces[scr->current_workspace]->clip) {
+        all_docks[ i++ ] = scr->workspaces[scr->current_workspace]->clip;
+    }
+
+    assert(i == scr->drawer_count + 2
+           - wPreferences.flags.nodock - wPreferences.flags.noclip);
+    for ( ; i < scr->drawer_count + 2; i++)
+        all_docks[ i ] = NULL;
 
     wins[0] = icon->core->window;
     wins[1] = scr->dock_shadow;
     XRestackWindows(dpy, wins, 2);
+    XMoveResizeWindow(dpy, scr->dock_shadow, aicon->x_pos, aicon->y_pos,
+		      ICON_SIZE, ICON_SIZE); /* Daniel: was only in dock.c */
     if (superfluous) {
         if (icon->pixmap!=None)
             ghost = MakeGhostIcon(scr, icon->pixmap);
         else
             ghost = MakeGhostIcon(scr, icon->core->window);
-        XSetWindowBackgroundPixmap(dpy, scr->dock_shadow,
-                                   ghost);
+        XSetWindowBackgroundPixmap(dpy, scr->dock_shadow, ghost);
         XClearWindow(dpy, scr->dock_shadow);
     }
+    if (ondock)
+        XMapWindow(dpy, scr->dock_shadow);
 
     while (!done) {
         WMMaskEvent(dpy, PointerMotionMask|ButtonReleaseMask|ButtonPressMask
@@ -673,8 +729,8 @@
 
         case MotionNotify:
             if (!grabbed) {
-                if (abs(dx-ev.xmotion.x)>=MOVE_THRESHOLD
-                    || abs(dy-ev.xmotion.y)>=MOVE_THRESHOLD) {
+                if (abs(ofs_x-ev.xmotion.x)>=MOVE_THRESHOLD
+                    || abs(ofs_y-ev.xmotion.y)>=MOVE_THRESHOLD) {
                     XChangeActivePointerGrab(dpy, ButtonMotionMask
                                              |ButtonReleaseMask|ButtonPressMask,
                                              wCursor[WCUR_MOVE], CurrentTime);
@@ -683,73 +739,86 @@
                     break;
                 }
             }
-            x = ev.xmotion.x_root - dx;
-            y = ev.xmotion.y_root - dy;
-
-            if (movingSingle) {
-                XMoveWindow(dpy, icon->core->window, x, y);
-            } else {
-                wAppIconMove(aicon, x, y);
+            if (omnipresent && !shown_clip_icons) {
+                for (i=0; i<scr->workspace_count; i++) {
+                    if (i == scr->current_workspace)
+                        continue;
+                    wDockShowIcons(scr->workspaces[i]->clip);
+                    /* Pb: if dock is collapsed (for instance, because
+                       it auto-collapses), its icons won't be shown. */
+                }
+                shown_clip_icons = True; /* avoid flickering */
             }
 
-            if (dockable) {
-                if (scr->dock && wDockSnapIcon(scr->dock, aicon, x, y,
-                                               &ix, &iy, False)) {
-                    shad_x = scr->dock->x_pos + ix*wPreferences.icon_size;
-                    shad_y = scr->dock->y_pos + iy*wPreferences.icon_size;
-
-                    if (scr->last_dock != scr->dock && collapsed) {
-                        scr->last_dock->collapsed = 1;
-                        wDockHideIcons(scr->last_dock);
-                        collapsed = 0;
-                    }
-                    if (!collapsed && (collapsed = scr->dock->collapsed)) {
-                        scr->dock->collapsed = 0;
-                        wDockShowIcons(scr->dock);
-                    }
-
-                    if (scr->dock->auto_raise_lower)
-                        wDockRaise(scr->dock);
-
-                    scr->last_dock = scr->dock;
-
-                    XMoveWindow(dpy, scr->dock_shadow, shad_x, shad_y);
-                    if (!docking) {
-                        XMapWindow(dpy, scr->dock_shadow);
+            x = ev.xmotion.x_root - ofs_x;
+            y = ev.xmotion.y_root - ofs_y;
+            if (dockable && !(aicon->running && (ev.xmotion.state & MOD_MASK))) {
+                for (i = 0; i < scr->drawer_count + 2; i++) {
+                    WDock *the_dock;
+                    if ((the_dock = all_docks[ i ]) == NULL)
+                        continue;
+                    tmp = wDockSnapIcon(the_dock, aicon,
+                                        x, y, &ix, &iy, (the_dock == original_dock));
+                    if (tmp) {
+                        /* Leave the dock we come from back in the
+                         * state we found it */
+                        if (last_dock && last_dock != the_dock) {
+                            if (last_dock->type == WM_DRAWER) {
+                                wDrawerFillTheGap(last_dock, aicon, (last_dock == original_dock));
+                            }
+                            if (collapsed) {
+                                last_dock->collapsed = 1;
+                                wDockHideIcons(last_dock);
+                                collapsed = 0;
+                            }
+                            if (last_dock->auto_raise_lower) {
+                                wDockLower(last_dock);
+                            }
+                        }
+                        /* expand this dock (if it's collapsed), save its state,
+                         * and do all this only once. All this is contained in the
+                         * following tests ! */
+                        if (!collapsed && (collapsed = the_dock->collapsed)) {
+                            the_dock->collapsed = 0;
+                            wDockShowIcons(the_dock);
+                        }
+                        /* if relevant, raise the new dock */
+                        if (last_dock != the_dock && the_dock->auto_raise_lower) {
+                            wDockRaise(the_dock);
+                            /* And raise the moving tile */
+                            wRaiseFrame(aicon->icon->core);
+                        }
+                        last_dock = the_dock;
+                        break;
                     }
-                    docking = 1;
-                } else if (workspace->clip &&
-                           wDockSnapIcon(workspace->clip, aicon, x, y,
-                                         &ix, &iy, False)) {
-                    shad_x = workspace->clip->x_pos + ix*wPreferences.icon_size;
-                    shad_y = workspace->clip->y_pos + iy*wPreferences.icon_size;
-
-                    if (scr->last_dock != workspace->clip && collapsed) {
-                        scr->last_dock->collapsed = 1;
-                        wDockHideIcons(scr->last_dock);
-                        collapsed = 0;
-                    }
-                    if (!collapsed && (collapsed = workspace->clip->collapsed)) {
-                        workspace->clip->collapsed = 0;
-                        wDockShowIcons(workspace->clip);
-                    }
-
-                    if (workspace->clip->auto_raise_lower)
-                        wDockRaise(workspace->clip);
+                }
+            }
 
-                    scr->last_dock = workspace->clip;
+            if ((!original_dock && tmp) ||
+                (original_dock && (aicon->launching
+                                   || aicon->lock
+                                   || (aicon->running && !(ev.xmotion.state & MOD_MASK))
+                                   || (!aicon->running && tmp)))) {
+                shad_x = last_dock->x_pos + ix*wPreferences.icon_size;
+                shad_y = last_dock->y_pos + iy*wPreferences.icon_size;
+
+		XMoveWindow(dpy, scr->dock_shadow, shad_x, shad_y);
+
+		if (!ondock) {
+		    XMapWindow(dpy, scr->dock_shadow);
+		}
+		ondock = 1;
+	    } else {
+                if (ondock) {
+                    XUnmapWindow(dpy, scr->dock_shadow);
 
-                    XMoveWindow(dpy, scr->dock_shadow, shad_x, shad_y);
-                    if (!docking) {
-                        XMapWindow(dpy, scr->dock_shadow);
+                    if (last_dock->type == WM_DRAWER) {
+                        wDrawerFillTheGap(last_dock, aicon, (last_dock == original_dock));
                     }
-                    docking = 1;
-                } else if (docking) {
-                    XUnmapWindow(dpy, scr->dock_shadow);
-                    docking = 0;
                 }
-            }
-
+		ondock = 0;
+	    }
+	    XMoveWindow(dpy, icon->core->window, x, y);
             break;
 
         case ButtonPress:
@@ -760,61 +829,137 @@
                 break;
             XUngrabPointer(dpy, CurrentTime);
 
-            if (docking) {
+	    if (ondock) {
                 Bool docked;
 
-                /* icon is trying to be docked */
-                SlideWindow(icon->core->window, x, y, shad_x, shad_y);
+		SlideWindow(icon->core->window, x, y, shad_x, shad_y);
                 XUnmapWindow(dpy, scr->dock_shadow);
-                docked = wDockAttachIcon(scr->last_dock, aicon, ix, iy);
-                if (scr->last_dock->auto_collapse) {
-                    collapsed = 0;
+
+                if (original_dock == NULL) { /* an undocked appicon trying to be docked */
+                    docked = wDockAttachIcon(last_dock, aicon, ix, iy);
+                    if (!docked) {
+                        /* if aicon wanted to go in a drawer, fill the gap */
+                        if (last_dock->type == WM_DRAWER) {
+                            wDrawerFillTheGap(last_dock, aicon, False);
+                        }
+                        /* If icon could not be docked, slide it back
+                         * to the old position */
+                        SlideWindow(icon->core->window, x, y, oldX, oldY);
+                    } else {
+                        wSoundPlay(WSOUND_DOCK);
+                    }
+                } else { /* a docked appicon, moving */
+                    if (original_dock == last_dock) {
+                        wDockReattachIcon(original_dock, aicon, ix, iy);
+
+                        for (i = 0; i < scr->drawer_count + 2; i++) {
+                            if (all_docks[i] && all_docks[i] != original_dock &&
+                                all_docks[i]->auto_raise_lower)
+                                wDockLower(all_docks[i]);
+                        }
+                    } else {
+                        docked = wDockMoveIconBetweenDocks(original_dock, last_dock, aicon, ix, iy);
+                        if (!docked) { /* aicon got rejected ! */
+                            /* if aicon wanted to go in a drawer, fill the gap */
+                            if (last_dock->type == WM_DRAWER) {
+                                wmessage("A drawer rejected the appicon !");
+                                wDrawerFillTheGap(last_dock, aicon, False);
+                            }
+                            /* If aicon comes from a drawer, make some room for it */
+                            if (original_dock->type == WM_DRAWER) {
+                                WAppIcon *aicons_to_shift[ original_dock->icon_count ];
+                                int j = 0;
+
+                                for (i = 0; i < original_dock->max_icons; i++) {
+                                    WAppIcon *ai = original_dock->icon_array[ i ];
+                                    if (ai && ai != aicon &&
+                                        abs(ai->xindex) >= abs(aicon->xindex))
+                                        aicons_to_shift[ j++ ] = ai;
+                                }
+                                if (j != original_dock->icon_count - abs(aicon->xindex) - 1)
+                                    wwarning("Shifting j=%d appicons (instead of %d!) to reinsert aicon at index %d.",
+                                             j, original_dock->icon_count - abs(aicon->xindex) - 1, aicon->xindex);
+                                wSlideAppicons(aicons_to_shift, j, original_dock->on_right_side);
+                            }
+                            SlideWindow(icon->core->window, x, y, aicon->x_pos,
+                                        aicon->y_pos);
+                            wDockReattachIcon(original_dock, aicon, aicon->xindex,aicon->yindex);
+                        }
+                        if ((last_dock->type == WM_CLIP || last_dock->type == WM_DRAWER)
+                            && last_dock->auto_collapse) {
+                            collapsed = 0;
+                        }
+                    }
                 }
-                if (workspace->clip &&
-                    workspace->clip != scr->last_dock &&
-                    workspace->clip->auto_raise_lower)
-                    wDockLower(workspace->clip);
-
-                if (!docked) {
-                    /* If icon could not be docked, slide it back to the old
-                     * position */
-                    SlideWindow(icon->core->window, x, y, oldX, oldY);
+            } else { /* ! ondock */
+                aicon->x_pos = x;
+                aicon->y_pos = y;
+
+                if (tmp) { /* maybe it could be docked but MOD was pressed */
+                    if (!last_dock) {
+                        wwarning("last_dock is null but tmp is true !");
+                    } else {
+                        if (last_dock->type == WM_DRAWER) {
+                            wDrawerFillTheGap(last_dock, aicon, (original_dock == last_dock));
+                        }
+                    }
                 }
 
-                wSoundPlay(WSOUND_DOCK);
-            } else {
-                if (movingSingle) {
-                    /* move back to its place */
-                    SlideWindow(icon->core->window, x, y, oldX, oldY);
-                    wAppIconMove(aicon, oldX, oldY);
-                } else {
-                    XMoveWindow(dpy, icon->core->window, x, y);
-                    aicon->x_pos = x;
-                    aicon->y_pos = y;
+                if (original_dock == NULL) { /* undocked appicon still undocked */
+		    XMoveWindow(dpy, icon->core->window, x, y);
+
+                    for (i = 0; i < scr->drawer_count + 2; i++) {
+                        if (all_docks[i] && all_docks[i]->auto_raise_lower)
+                            wDockLower(all_docks[i]);
+                    }
+                } else { /* detach docked appicon */
+                    if (superfluous) {
+                        if (!aicon->running && !wPreferences.no_animations) {
+                            /* We need to deselect it, even if is deselected
+                             * in wDockDetach(), because else DoKaboom() will
+                             * fail. */
+                            if (aicon->icon->selected)
+                                wIconSelect(aicon->icon);
+
+                            wSoundPlay(WSOUND_KABOOM);
+                            DoKaboom(scr,aicon->icon->core->window, x, y);
+                        } else {
+                            wSoundPlay(WSOUND_UNDOCK);
+                        }
+                    } else {
+                        wSoundPlay(WSOUND_UNDOCK);
+                    }
+
+                    for (i = 0; i < scr->drawer_count + 2; i++) {
+                        if (all_docks[i] && all_docks[i]->auto_raise_lower)
+                            wDockLower(all_docks[i]);
+                    }
+                    wDockDetach(original_dock, aicon);
                 }
-                if (workspace->clip && workspace->clip->auto_raise_lower)
-                    wDockLower(workspace->clip);
             }
             if (collapsed) {
-                scr->last_dock->collapsed = 1;
-                wDockHideIcons(scr->last_dock);
+                last_dock->collapsed = 1;
+                wDockHideIcons(last_dock);
                 collapsed = 0;
             }
             if (superfluous) {
-                if (ghost!=None)
-                    XFreePixmap(dpy, ghost);
-                XSetWindowBackground(dpy, scr->dock_shadow, scr->white_pixel);
+		if (ghost!=None)
+		    XFreePixmap(dpy, ghost);
+		XSetWindowBackground(dpy, scr->dock_shadow, scr->white_pixel);
+            }
+            if (shown_clip_icons) {
+                for (i=0; i<scr->workspace_count; i++) {
+                    if (i == scr->current_workspace)
+                        continue;
+                    wDockHideIcons(scr->workspaces[i]->clip);
+                }
             }
-
             if (wPreferences.auto_arrange_icons)
-                wArrangeIcons(scr, True);
-
-            done = 1;
-            break;
-        }
-    }
+                wArrangeIcons(scr, True); /* Daniel: was only in appicon.c */
 #ifdef DEBUG
-    puts("End icon move");
+	    puts("End appicon move");
 #endif
-
+            return;
+        }
+    }
 }
diff -Naur WindowMaker-0.92.0-orig/src/appicon.h WindowMaker-0.92.0/src/appicon.h
--- WindowMaker-0.92.0-orig/src/appicon.h	2004-10-14 19:31:49.000000000 +0200
+++ WindowMaker-0.92.0/src/appicon.h	2007-01-10 23:45:02.000000000 +0100
@@ -97,5 +97,7 @@
 
 void wAppIconMove(WAppIcon *aicon, int x, int y);
 
+void wHandleAppIconMove(WAppIcon *aicon, XEvent *event);
+
 #endif
 
diff -Naur WindowMaker-0.92.0-orig/src/application.c WindowMaker-0.92.0/src/application.c
--- WindowMaker-0.92.0-orig/src/application.c	2005-03-11 22:35:36.000000000 +0100
+++ WindowMaker-0.92.0/src/application.c	2007-01-10 23:45:02.000000000 +0100
@@ -332,7 +332,7 @@
         if (!wapp->app_icon && scr->dock) {
             wapp->app_icon = findDockIconFor(scr->dock, main_window);
         }
-        /* finally check clips */
+        /* Check clips */
         if (!wapp->app_icon) {
             int i;
             for (i=0; i<scr->workspace_count; i++) {
@@ -343,6 +343,15 @@
                     break;
             }
         }
+        /* Check drawers too */
+        if (!wapp->app_icon) {
+            WDrawerChain *dc;
+            for (dc = scr->drawers; dc != NULL; dc = dc->next) {
+                wapp->app_icon = findDockIconFor(dc->adrawer, main_window);
+                if (wapp->app_icon)
+                    break;
+            }
+        }
 
         if (wapp->app_icon) {
             WWindow *mainw = wapp->main_window_desc;
@@ -366,23 +375,29 @@
 
     if (wapp->app_icon && !wapp->app_icon->docked) {
         WIcon *icon = wapp->app_icon->icon;
-        WDock *clip = scr->workspaces[scr->current_workspace]->clip;
+        WDock *attracting_dock;
         int x=0, y=0;
 
-        if (clip && clip->attract_icons && wDockFindFreeSlot(clip, &x, &y)) {
+        if (scr->attracting_drawer)
+            attracting_dock = scr->attracting_drawer;
+        else
+            attracting_dock = scr->workspaces[scr->current_workspace]->clip;
+
+        if (attracting_dock && attracting_dock->attract_icons &&
+            wDockFindFreeSlot(attracting_dock, &x, &y)) {
             wapp->app_icon->attracted = 1;
             if (!icon->shadowed) {
                 icon->shadowed = 1;
                 icon->force_paint = 1;
                 /* wAppIconPaint() is done in wDockAttachIcon() below */
             }
-            wDockAttachIcon(clip, wapp->app_icon, x, y);
+            wDockAttachIcon(attracting_dock, wapp->app_icon, x, y);
         } else {
             PlaceIcon(scr, &x, &y, wGetHeadForWindow(wapp->main_window_desc));
             wAppIconMove(wapp->app_icon, x, y);
             wLowerFrame(icon->core);
         }
-        if (!clip || !wapp->app_icon->attracted || !clip->collapsed)
+        if (!wapp->app_icon->attracted || !attracting_dock->collapsed)
             XMapWindow(dpy, icon->core->window);
     }
 
@@ -479,6 +494,9 @@
             wAppIconPaint(wapp->app_icon);
         } else if (wapp->app_icon->docked) {
             wapp->app_icon->running = 0;
+            if (wapp->app_icon->dock->type == WM_DRAWER) {
+                wDrawerFillTheGap(wapp->app_icon->dock, wapp->app_icon, True);
+            }
             wDockDetach(wapp->app_icon->dock, wapp->app_icon);
         } else {
             wAppIconDestroy(wapp->app_icon);
diff -Naur WindowMaker-0.92.0-orig/src/defaults.c WindowMaker-0.92.0/src/defaults.c
--- WindowMaker-0.92.0-orig/src/defaults.c	2007-01-10 23:36:31.000000000 +0100
+++ WindowMaker-0.92.0/src/defaults.c	2007-01-10 23:45:03.000000000 +0100
@@ -1509,6 +1509,7 @@
 wDefaultUpdateIcons(WScreen *scr)
 {
     WAppIcon *aicon = scr->app_icon_list;
+    WDrawerChain *dc;
     WWindow *wwin = scr->focused_window;
     char *file;
 
@@ -1536,6 +1537,9 @@
     if (!wPreferences.flags.noclip)
         wClipIconPaint(scr->clip_icon);
 
+    for (dc = scr->drawers; dc != NULL; dc = dc->next)
+        wDrawerIconPaint(dc->adrawer->icon_array[0]);
+
     while (wwin) {
         if (wwin->icon && wwin->flags.miniaturized) {
             file = wDefaultGetIconFile(scr, wwin->wm_instance, wwin->wm_class,
@@ -3005,6 +3009,11 @@
         scr->clip_tile = wClipMakeTile(scr, img);
     }
 
+    if (scr->drawer_tile) {
+        RReleaseImage(scr->drawer_tile);
+    }
+    scr->drawer_tile = wDrawerMakeTile(scr, img);
+
     scr->icon_tile_pixmap = pixmap;
 
     if (scr->def_icon_pixmap) {
diff -Naur WindowMaker-0.92.0-orig/src/defaults.h WindowMaker-0.92.0/src/defaults.h
--- WindowMaker-0.92.0-orig/src/defaults.h	2004-10-12 19:54:32.000000000 +0200
+++ WindowMaker-0.92.0/src/defaults.h	2007-01-10 23:45:03.000000000 +0100
@@ -63,5 +63,7 @@
 
 void wDefaultChangeIcon(WScreen *scr, char *instance, char* class, char *file);
 
+void wDefaultPurgeInfo(WScreen *scr, char *instance, char *class);
+
 #endif /* WMDEFAULTS_H_ */
 
